﻿EnableExplicit

;Code here to check preferences or locale to set default language



;Includes and procedures to set language
IncludeFile "Locale.pbi"
Locale::AppLanguage = "en_GB" ;Set default language
Locale::Initialise()
Locale::SelectLanguage()

Global Window_0.i, DBID.i

Global  txtCategory, cmbCategory, txtPhrase, cmbPhrase, edtPhrase, btnSelect, btnExit

Global CurrentVar.s

Define Event.i

Procedure OpenLangDB()
  
  DBID = OpenDatabase(#PB_Any,GetCurrentDirectory() + "Resources\" + Locale::AppLanguage + ".lng","","") 
  
EndProcedure

Procedure LoadCategories()
  
  Define Criteria.s
  Define iLoop.i
  
  Criteria  = "SELECT * FROM Category;"
  ClearGadgetItems(cmbCategory)
  DatabaseQuery(DBID,criteria)
  FirstDatabaseRow(DBID)
  AddGadgetItem(cmbCategory,iLoop,GetDatabaseString(DBID,DatabaseColumnIndex(DBID,"Title")))
  SetGadgetItemData(cmbCategory,0,GetDatabaseLong(DBID,DatabaseColumnIndex(DBID,"Category_ID")))
  iLoop = 1
  While NextDatabaseRow(DBID)
    AddGadgetItem(cmbCategory,iLoop,GetDatabaseString(DBID,DatabaseColumnIndex(DBID,"Title")))    
    SetGadgetItemData(cmbCategory,iLoop,GetDatabaseLong(DBID,DatabaseColumnIndex(DBID,"Category_ID")))    
    iLoop = iLoop + 1  
  Wend
  FinishDatabaseQuery(DBID)
  
EndProcedure

Procedure LoadPhrases()
        
  Define Criteria.s
  Define iLoop.i

  ClearGadgetItems(cmbPhrase)
  SetGadgetText(edtPhrase,"")
  Criteria  = "SELECT * FROM Phrases Where Category_ID = " + Str(GetGadgetItemData(cmbCategory,GetGadgetState(cmbCategory))) + ";"
  DatabaseQuery(DBID,criteria)
  FirstDatabaseRow(DBID)
  AddGadgetItem(cmbPhrase,0,GetDatabaseString(DBID,DatabaseColumnIndex(DBID,"Phrase")))
  SetGadgetItemData(cmbPhrase,0,GetDatabaseLong(DBID,DatabaseColumnIndex(DBID,"Phrase_ID")))  
  iLoop = 1
  While NextDatabaseRow(DBID)
    AddGadgetItem(cmbPhrase,-1,GetDatabaseString(DBID,DatabaseColumnIndex(DBID,"Phrase")))    
    SetGadgetItemData(cmbPhrase,iLoop,GetDatabaseLong(DBID,DatabaseColumnIndex(DBID,"Phrase_ID")))    
    iLoop = iLoop + 1    
  Wend
  FinishDatabaseQuery(DBID)
  
EndProcedure

Procedure SelectPhrase()
  
  Define Criteria.s

  Criteria  = "SELECT * FROM Phrases Where Phrase_ID = " + Str(GetGadgetItemData(cmbPhrase,GetGadgetState(cmbPhrase))) + ";"
  DatabaseQuery(DBID,criteria)
  FirstDatabaseRow(DBID)
  
  SetGadgetText(edtPhrase,GetDatabaseString(DBID,DatabaseColumnIndex(DBID,"Phrase")))
  CurrentVar = "Locale::" + GetDatabaseString(DBID,DatabaseColumnIndex(DBID,"Key"))
  FinishDatabaseQuery(DBID)
  
EndProcedure

Window_0 = OpenWindow(#PB_Any, 0, 0, 280, 190, Locale::AP_0001, #PB_Window_Tool | #PB_Window_ScreenCentered)
txtCategory = TextGadget(#PB_Any, 10, 10, 120, 20, Locale::AP_0002)
cmbCategory = ComboBoxGadget(#PB_Any, 130, 10, 140, 20)
txtPhrase = TextGadget(#PB_Any, 10, 40, 120, 20, Locale::AP_0003)
cmbPhrase = ComboBoxGadget(#PB_Any, 130, 40, 140, 20)
edtPhrase = EditorGadget(#PB_Any, 10, 70, 260, 70)
btnSelect = ButtonGadget(#PB_Any, 10, 150, 70, 30, Locale::CM_0027)
btnExit = ButtonGadget(#PB_Any, 200, 150, 70, 30, Locale::CM_0017)

;Open Selected Language File
OpenLangDB()

;Load Categories
LoadCategories()

Repeat
  
  Event = WaitWindowEvent()
  
  Select Event

    Case #PB_Event_Gadget
      Select EventGadget()
          
        Case cmbCategory
          LoadPhrases()
          
        Case cmbPhrase
          SelectPhrase()
          
        Case btnSelect
          SetClipboardText(CurrentVar)

        Case btnExit
          End
          
      EndSelect
  EndSelect
  
ForEver
; IDE Options = PureBasic 5.42 LTS (Windows - x64)
; CursorPosition = 90
; FirstLine = 26
; Folding = x
; EnableUnicode
; EnableXP